/*
 * Copyright (c) 2014-2015, The Linux Foundation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifdef CONFIG_ARCH_ATLAS7
#define CLKC_BASE		0x18620000
#define CLKC_REG(offset)		(CLKC_BASE + (offset))

#define PLLOUT_EN1		0x00001000
#define ABPLL_BYP		0x00000010
#define ABPLL_RESET_EN		0x00000001
#define ALLCLK_EN		0xffffffff

#define BIT(x)		(1 << (x))

#define CLKC_MEMPLL_AB_FREQ		    CLKC_REG(0x000)
#define CLKC_MEMPLL_AB_SSC		    CLKC_REG(0x004)
#define CLKC_MEMPLL_AB_CTRL0		CLKC_REG(0x008)
#define CLKC_MEMPLL_AB_CTRL1		CLKC_REG(0x00c)
#define CLKC_MEMPLL_AB_STATUS		CLKC_REG(0x010)
#define CLKC_MEMPLL_AB_SSRAM_ADDR	CLKC_REG(0x014)
#define CLKC_MEMPLL_AB_SSRAM_DATA	CLKC_REG(0x018)
#define CLKC_CPUPLL_AB_FREQ		    CLKC_REG(0x01c)
#define CLKC_CPUPLL_AB_SSC		    CLKC_REG(0x020)
#define CLKC_CPUPLL_AB_CTRL0		CLKC_REG(0x024)
#define CLKC_CPUPLL_AB_CTRL1		CLKC_REG(0x028)
#define CLKC_CPUPLL_AB_STATUS		CLKC_REG(0x02c)
#define CLKC_SYS0_BTPLL_AB_FREQ		CLKC_REG(0x030)
#define CLKC_SYS0_BTPLL_AB_SSC		CLKC_REG(0x034)
#define CLKC_SYS0_BTPLL_AB_CTRL0	CLKC_REG(0x038)
#define CLKC_SYS0_BTPLL_AB_CTRL1	CLKC_REG(0x03c)
#define CLKC_SYS0_BTPLL_AB_STATUS	CLKC_REG(0x040)
#define CLKC_SYS1_USBPLL_AB_FREQ	CLKC_REG(0x044)
#define CLKC_SYS1_USBPLL_AB_SSC		CLKC_REG(0x048)
#define CLKC_SYS1_USBPLL_AB_CTRL0	CLKC_REG(0x04c)
#define CLKC_SYS1_USBPLL_AB_CTRL1	CLKC_REG(0x050)
#define CLKC_SYS1_USBPLL_AB_STATUS	CLKC_REG(0x054)
#define CLKC_SYS2_ETHPLL_AB_FREQ	CLKC_REG(0x058)
#define CLKC_SYS2_ETHPLL_AB_SSC		CLKC_REG(0x05c)
#define CLKC_SYS2_ETHPLL_AB_CTRL0	CLKC_REG(0x060)
#define CLKC_SYS2_ETHPLL_AB_CTRL1	CLKC_REG(0x064)
#define CLKC_SYS2_ETHPLL_AB_STATUS	CLKC_REG(0x068)
#define CLKC_SYS3_SSCPLL_AB_FREQ	CLKC_REG(0x06c)
#define CLKC_SYS3_SSCPLL_AB_SSC		CLKC_REG(0x070)
#define CLKC_SYS3_SSCPLL_AB_CTRL0	CLKC_REG(0x074)
#define CLKC_SYS3_SSCPLL_AB_CTRL1	CLKC_REG(0x078)
#define CLKC_SYS3_SSCPLL_AB_STATUS	CLKC_REG(0x07c)
#define CLKC_SYS3_SSCPLL_AB_SSRAM_ADDR	CLKC_REG(0x080)
#define CLKC_SYS3_SSCPLL_AB_SSRAM_DATA	CLKC_REG(0x084)
#define CLKC_AUDIO_DTO_INC		    CLKC_REG(0x088)
#define CLKC_DISP0_DTO_INC			CLKC_REG(0x08c)
#define CLKC_DISP1_DTO_INC			CLKC_REG(0x090)
#define CLKC_AUDIO_DTO_SRC			CLKC_REG(0x094)
#define CLKC_AUDIO_DTO_ENA			CLKC_REG(0x098)
#define CLKC_AUDIO_DTO_DROFF		CLKC_REG(0x09c)
#define CLKC_DISP0_DTO_SRC			CLKC_REG(0x0a0)
#define CLKC_DISP0_DTO_ENA			CLKC_REG(0x0a4)
#define CLKC_DISP0_DTO_DROFF		CLKC_REG(0x0a8)
#define CLKC_DISP1_DTO_SRC			CLKC_REG(0x0ac)
#define CLKC_DISP1_DTO_ENA			CLKC_REG(0x0b0)
#define CLKC_DISP1_DTO_DROFF		CLKC_REG(0x0b4)
#define CLKC_I2S_CLK_SEL			CLKC_REG(0x0b8)
#define CLKC_I2S_CLK_SEL_STATUS		CLKC_REG(0x0bc)
#define CLKC_USBPHY_CLK_CFG			CLKC_REG(0x0c0)
#define CLKC_USBPHY_CLK_DIVENA		CLKC_REG(0x0c4)
#define CLKC_USBPHY_CLK_SEL			CLKC_REG(0x0c8)
#define CLKC_USBPHY_CLK_SEL_STATUS	CLKC_REG(0x0cc)
#define CLKC_BTSS_CLK_CFG		    CLKC_REG(0x0d0)
#define CLKC_BTSS_CLK_DIVENA		CLKC_REG(0x0d4)
#define CLKC_BTSS_CLK_SEL			CLKC_REG(0x0d8)
#define CLKC_BTSS_CLK_SEL_STATUS	CLKC_REG(0x0dc)
#define CLKC_RGMII_CLK_CFG	        CLKC_REG(0x0e0)
#define CLKC_RGMII_CLK_DIVENA		CLKC_REG(0x0e4)
#define CLKC_RGMII_CLK_SEL			CLKC_REG(0x0e8)
#define CLKC_RGMII_CLK_SEL_STATUS	CLKC_REG(0x0ec)
#define CLKC_CPU_CLK_CFG			CLKC_REG(0x0f0)
#define CLKC_CPU_CLK_DIVENA			CLKC_REG(0x0f4)
#define CLKC_CPU_CLK_SEL			CLKC_REG(0x0f8)
#define CLKC_CPU_CLK_SEL_STATUS		CLKC_REG(0x0fc)
#define CLKC_SDPHY01_CLK_CFG		CLKC_REG(0x100)
#define CLKC_SDPHY01_CLK_DIVENA		CLKC_REG(0x104)
#define CLKC_SDPHY01_CLK_SEL		CLKC_REG(0x108)
#define CLKC_SDPHY01_CLK_SEL_STATUS	CLKC_REG(0x10c)
#define CLKC_SDPHY23_CLK_CFG		CLKC_REG(0x110)
#define CLKC_SDPHY23_CLK_DIVENA		CLKC_REG(0x114)
#define CLKC_SDPHY23_CLK_SEL		CLKC_REG(0x118)
#define CLKC_SDPHY23_CLK_SEL_STATUS	CLKC_REG(0x11c)
#define CLKC_SDPHY45_CLK_CFG		CLKC_REG(0x120)
#define CLKC_SDPHY45_CLK_DIVENA		CLKC_REG(0x124)
#define CLKC_SDPHY45_CLK_SEL		CLKC_REG(0x128)
#define CLKC_SDPHY45_CLK_SEL_STATUS	CLKC_REG(0x12c)
#define CLKC_SDPHY67_CLK_CFG		CLKC_REG(0x130)
#define CLKC_SDPHY67_CLK_DIVENA		CLKC_REG(0x134)
#define CLKC_SDPHY67_CLK_SEL		CLKC_REG(0x138)
#define CLKC_SDPHY67_CLK_SEL_STATUS	CLKC_REG(0x13c)
#define CLKC_CAN_CLK_CFG		    CLKC_REG(0x140)
#define CLKC_CAN_CLK_DIVENA		    CLKC_REG(0x144)
#define CLKC_CAN_CLK_SEL			CLKC_REG(0x148)
#define CLKC_CAN_CLK_SEL_STATUS		CLKC_REG(0x14c)
#define CLKC_DEINT_CLK_CFG			CLKC_REG(0x150)
#define CLKC_DEINT_CLK_DIVENA		CLKC_REG(0x154)
#define CLKC_DEINT_CLK_SEL			CLKC_REG(0x158)
#define CLKC_DEINT_CLK_SEL_STATUS	CLKC_REG(0x15c)
#define CLKC_NAND_CLK_CFG			CLKC_REG(0x160)
#define CLKC_NAND_CLK_DIVENA		CLKC_REG(0x164)
#define CLKC_NAND_CLK_SEL			CLKC_REG(0x168)
#define CLKC_NAND_CLK_SEL_STATUS	CLKC_REG(0x16c)
#define CLKC_DISP0_CLK_CFG			CLKC_REG(0x170)
#define CLKC_DISP0_CLK_DIVENA		CLKC_REG(0x174)
#define CLKC_DISP0_CLK_SEL			CLKC_REG(0x178)
#define CLKC_DISP0_CLK_SEL_STATUS	CLKC_REG(0x17c)
#define CLKC_DISP1_CLK_CFG		    CLKC_REG(0x180)
#define CLKC_DISP1_CLK_DIVENA		CLKC_REG(0x184)
#define CLKC_DISP1_CLK_SEL			CLKC_REG(0x188)
#define CLKC_DISP1_CLK_SEL_STATUS	CLKC_REG(0x18c)
#define CLKC_GPU_CLK_CFG			CLKC_REG(0x190)
#define CLKC_GPU_CLK_DIVENA			CLKC_REG(0x194)
#define CLKC_GPU_CLK_SEL			CLKC_REG(0x198)
#define CLKC_GPU_CLK_SEL_STATUS		CLKC_REG(0x19c)
#define CLKC_GNSS_CLK_CFG			CLKC_REG(0x1a0)
#define CLKC_GNSS_CLK_DIVENA		CLKC_REG(0x1a4)
#define CLKC_GNSS_CLK_SEL			CLKC_REG(0x1a8)
#define CLKC_GNSS_CLK_SEL_STATUS	CLKC_REG(0x1ac)
#define CLKC_SHARED_DIVIDERS_CFG0	CLKC_REG(0x1b0)
#define CLKC_SHARED_DIVIDERS_CFG1	CLKC_REG(0x1b4)
#define CLKC_SHARED_DIVIDERS_ENA	CLKC_REG(0x1b8)
#define CLKC_SYS_CLK_SEL			CLKC_REG(0x1bc)
#define CLKC_SYS_CLK_SEL_STATUS		CLKC_REG(0x1c0)
#define CLKC_IO_CLK_SEL			    CLKC_REG(0x1c4)
#define CLKC_IO_CLK_SEL_STATUS		CLKC_REG(0x1c8)
#define CLKC_G2D_CLK_SEL			CLKC_REG(0x1cc)
#define CLKC_G2D_CLK_SEL_STATUS		CLKC_REG(0x1d0)
#define CLKC_JPENC_CLK_SEL			CLKC_REG(0x1d4)
#define CLKC_JPENC_CLK_SEL_STATUS	CLKC_REG(0x1d8)
#define CLKC_VDEC_CLK_SEL			CLKC_REG(0x1dc)
#define CLKC_VDEC_CLK_SEL_STATUS	CLKC_REG(0x1e0)
#define CLKC_GMAC_CLK_SEL			CLKC_REG(0x1e4)
#define CLKC_GMAC_CLK_SEL_STATUS	CLKC_REG(0x1e8)
#define CLKC_USB_CLK_SEL			CLKC_REG(0x1ec)
#define CLKC_USB_CLK_SEL_STATUS		CLKC_REG(0x1f0)
#define CLKC_KAS_CLK_SEL			CLKC_REG(0x1f4)
#define CLKC_KAS_CLK_SEL_STATUS		CLKC_REG(0x1f8)
#define CLKC_SEC_CLK_SEL			CLKC_REG(0x1fc)
#define CLKC_SEC_CLK_SEL_STATUS		CLKC_REG(0x200)
#define CLKC_SDR_CLK_SEL			CLKC_REG(0x204)
#define CLKC_SDR_CLK_SEL_STATUS		CLKC_REG(0x208)
#define CLKC_VIP_CLK_SEL			CLKC_REG(0x20c)
#define CLKC_VIP_CLK_SEL_STATUS		CLKC_REG(0x210)
#define CLKC_NOCD_CLK_SEL			CLKC_REG(0x214)
#define CLKC_NOCD_CLK_SEL_STATUS	CLKC_REG(0x218)
#define CLKC_NOCR_CLK_SEL			CLKC_REG(0x21c)
#define CLKC_NOCR_CLK_SEL_STATUS	CLKC_REG(0x220)
#define CLKC_TPIU_CLK_SEL			CLKC_REG(0x224)
#define CLKC_TPIU_CLK_SEL_STATUS	CLKC_REG(0x228)
#define CLKC_HSI2S_CLK_SEL			CLKC_REG(0x22C)
#define CLKC_HSI2S_CLK_SEL_STATUS	CLKC_REG(0x230)

#define CLKC_ROOT_CLK_EN0_SET			CLKC_REG(0x234)
#define CLKC_ROOT_CLK_EN1_SET			CLKC_REG(0x240)
#define CLKC_MISC1_LEAF_CLK_EN_SET		CLKC_REG(0x258)
#define CLKC_MISC1_LEAF_CLK_EN_CLR		CLKC_REG(0x25C)
#define CLKC_MISC2_LEAF_CLK_EN_SET		CLKC_REG(0x264)
#define CLKC_MISC2_LEAF_CLK_EN_CLR		CLKC_REG(0x268)
#define CLKC_SDIO01_LEAF_CLK_EN_SET		CLKC_REG(0x2AC)
#define CLKC_SDIO01_LEAF_CLK_EN_CLR		CLKC_REG(0x2B0)
#define CLKC_SDIO23_LEAF_CLK_EN_SET		CLKC_REG(0x2B8)
#define CLKC_SDIO23_LEAF_CLK_EN_CLR		CLKC_REG(0x2BC)
#define CLKC_DMAC0_LEAF_CLK_EN_SET		CLKC_REG(0x2F4)
#define CLKC_DMAC0_LEAF_CLK_EN_CLR		CLKC_REG(0x2F8)
#define CLKC_DMAC1_LEAF_CLK_EN_SET		CLKC_REG(0x270)
#define CLKC_DMAC1_LEAF_CLK_EN_CLR		CLKC_REG(0x274)
#define CLKC_DMAC2_LEAF_CLK_EN_SET		CLKC_REG(0x27C)
#define CLKC_DMAC2_LEAF_CLK_EN_CLR		CLKC_REG(0x280)
#define CLKC_DMAC3_LEAF_CLK_EN_SET		CLKC_REG(0x288)
#define CLKC_DMAC3_LEAF_CLK_EN_CLR		CLKC_REG(0x28C)
#define CLKC_BT_LEAF_CLK_EN_SET		    CLKC_REG(0x33C)
#define CLKC_BT_LEAF_CLK_EN_CLR		    CLKC_REG(0x340)

#define CLKC_MEM_LEAF_CLK_EN_SET		CLKC_REG(0x318)
#define CLKC_MEM_LEAF_CLK_EN_CLR		CLKC_REG(0x31C)
#define CLKC_MEM_LEAF_CLK_EN_STATUS		CLKC_REG(0x320)
#define CLKC_RSTC_MISC1_SW_RST_SET		CLKC_REG(0x360)
#define CLKC_RSTC_MISC1_SW_RST_CLR		CLKC_REG(0x364)
#define CLKC_RSTC_MEM_SW_RST_SET		CLKC_REG(0x420)
#define CLKC_RSTC_MEM_SW_RST_CLR		CLKC_REG(0x424)
#define CLKC_RSTC_MEM_SW_RST_STATUS		CLKC_REG(0x428)

#define CLKC_RSTC_STATUS			CLKC_REG(0x4c0)
#define CLKC_CLKC_SW_REG0			CLKC_REG(0x464)
#define CLKC_CLKC_SW_REG1			CLKC_REG(0x468)
#define CLKC_CLKC_SW_REG2			CLKC_REG(0x46c)
#define CLKC_CLKC_SW_REG3			CLKC_REG(0x470)
#define CLKC_CLKC_SW_REG4			CLKC_REG(0x474)
#define CLKC_CLKC_SW_REG5			CLKC_REG(0x478)

/* fields for register CLKC_ROOT_CLK_EN0_SET */
#define CLKC_ROOT_CLK_EN0_SET_AUDMSCM_KAS	BIT(0)
#define CLKC_ROOT_CLK_EN0_SET_GNSS		BIT(1)
#define CLKC_ROOT_CLK_EN0_SET_GPU		BIT(2)
#define CLKC_ROOT_CLK_EN0_SET_G2D		BIT(3)
#define CLKC_ROOT_CLK_EN0_SET_JPENC		BIT(4)
#define CLKC_ROOT_CLK_EN0_SET_DISP0		BIT(5)
#define CLKC_ROOT_CLK_EN0_SET_DISP1		BIT(6)
#define CLKC_ROOT_CLK_EN0_SET_I2S		BIT(8)
#define CLKC_ROOT_CLK_EN0_SET_AUDMSCM_IO	BIT(11)
#define CLKC_ROOT_CLK_EN0_SET_VDIFM_IO		BIT(12)
#define CLKC_ROOT_CLK_EN0_SET_GNSSM_IO		BIT(13)
#define CLKC_ROOT_CLK_EN0_SET_MEDIAM_IO		BIT(14)
#define CLKC_ROOT_CLK_EN0_SET_BTM_IO		BIT(17)
#define CLKC_ROOT_CLK_EN0_SET_SDPHY01		BIT(18)
#define CLKC_ROOT_CLK_EN0_SET_SDPHY23		BIT(19)
#define CLKC_ROOT_CLK_EN0_SET_SDPHY45		BIT(20)
#define CLKC_ROOT_CLK_EN0_SET_SDPHY67		BIT(21)
#define CLKC_ROOT_CLK_EN0_SET_AUDMSCM_XIN	BIT(22)
#define CLKC_ROOT_CLK_EN0_SET_NAND		BIT(27)
#define CLKC_ROOT_CLK_EN0_SET_GNSSM_RTCM_SEC	BIT(28)
#define CLKC_ROOT_CLK_EN0_SET_CPUM_CPU		BIT(29)
#define CLKC_ROOT_CLK_EN0_SET_GNSSM_XIN		BIT(30)
#define CLKC_ROOT_CLK_EN0_SET_VIP		BIT(31)

#define CLKC_MISC1_LEAF_SYS2PCI_IO_CLKEN	BIT(3)
#define CLKC_MISC1_LEAF_PCIARB_IO_CLKEN		BIT(4)
#define CLKC_MISC1_LEAF_SYS2PCI2_IO_CLKEN	BIT(7)

#define CLKC_SDIO_LEAF_IO_CLKEN			BIT(0)
#define CLKC_SDIO_LEAF_SDPHY_CLKEN		BIT(1)
#define CLKC_DMAC0_LEAF_UART0_IO_CLKEN		BIT(1)

#endif
